﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="JsTreeSample._Default" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title></title>
    <script type="text/javascript" src="_scr/json.js"></script>
	<script type="text/javascript" src="_scr/jsTree/lib/jquery.js"></script>
	<script type="text/javascript" src="_scr/jsTree/lib/sarissa.js"></script>
	<script type="text/javascript" src="_scr/jsTree/jquery.tree.js"></script>
	<script type="text/javascript" src="_scr/jsTree/plugins/jquery.tree.xml_nested.js"></script>    
	
	<style type="text/css">
		body, html { font-size: 12px;}

		.clear:after {
			content: ".";
			display: block;
			height: 0;
			clear: both;
			visibility: hidden;
		}

		/* IE6 */
		.clear {display: inline-table;}

		/* IE7 */
		*:first-child+html .clear {display: inline-block;}

		/* Hides from IE-mac \*/
		* html .clear {height: 1%;}
		.clear {display: block;}
		/* End hide from IE-mac */

		#xml-t { border: 1px solid #ccc;}
		#xml-d, #node-d, #md { width: 100%; height: 150px; font-family: 'Lucida Console'; font-size: 11px; margin-top: 10px;}
	</style>	
	
	<script type="text/javascript">
	    //http://code.google.com/p/jstree/issues/detail?id=430

	    jQuery.ajaxSetup({ xhr: function() {
	        //return new window.XMLHttpRequest();
	        try {
	            if (window.ActiveXObject)
	                return new window.ActiveXObject("Microsoft.XMLHTTP");
	        } catch (e) { }
	        return new window.XMLHttpRequest();
	    }
	    });


	    function TreeController() {
	    }

	    TreeController.prototype.wireEvents = function() {
	        /*--- adds a new node as a child of the current node ---*/
	        $("#add").click(function(e) {
	            var t = $.tree.focused();

	            if (t.selected) {
	                t.create();
	            }
	            else {
	                alert("Select a node first");
	            }
	        });

	        /*--- rename the currently selected node ---*/
	        $("#rename").click(function(e) {
	            var t = $.tree.focused();

	            if (t.selected) {
	                t.rename();
	            }
	        });

	        /*--- delete the current non-root node ---*/
	        $("#delete").click(function(e) {
	            var t = $.tree.focused();

	            // Do not allow deletion of the root node.
	            if (t.selected && t.parent(t.selected) != -1) {
	                t.remove();
	            }
	        });

	        /*--- reads the XML and displays in the xml-d element ---*/
	        $("#xml").click(function() {
	            var t = $.tree.focused();

	            if (t.selected) {
	                //$("#node-d").text(JSON.stringify(t.selected));

	                $("#xml-d").text(t.get());
	            }
	        });

	        /*--- test adding data ---*/
	        $("#test").click(function() {
	            var t = $.tree.focused();

	            if (!t.selected) {
	                return;
	            }
	            
                /*--- sample of sending a JSON object ---*/
	            var person = {
	                "FirstName": $("#firstName").val(),
	                "LastName": $("#lastName").val(),
	                "Age": $("#age").val() 
                };
                
                var serialized = JSON.stringify(person);

                /*--- sample of adding an arbitrary attribute at the DOM level ---*/
                t.selected.attr("md", encodeURI(serialized));

                /*--- ...and how to retrieve it in XML ---*/
                var opts = {};
                opts.outer_attrib = ["id", "rel", "class", "md"];

                var xml = t.get(null, "xml_nested", opts)

                $("#xml-d").text(xml);
                $("#treeXml").val(encodeURI(xml));	            
	        });
	    }

	    var tc = new TreeController();
	    var defaultXml = "<root> <item id='node_id' state='open' attribute='value'> <content> <name><![CDATA[Root node 1]]></name> </content> <item id='node_id' state='open' attribute='value'> <content> <name><![CDATA[Child node 1]]></name> </content> </item> </item> <item id='node_id' attribute='value'> <content> <name><![CDATA[Root node 2]]></name> </content> </item> </root>";

	    $(document).ready(function() {
	        $("#xml-t").tree({
	            data: {
	                type: "xml_nested",
	                opts: {
	                    staticData: defaultXml
	                }
	            }
	        });

	        tc.wireEvents();
	    });
	</script>	
</head>
<body>
    <form id="form1" runat="server">
		<div style="margin-bottom: 10px;">
			<input type="button" id="add" value="Add"/>
			<input type="button" id="rename" value="Rename"/>
			<input type="button" id="delete" value="Delete"/>
			<input type="button" id="xml" value="Get XML"/>			
			<asp:Button ID="_submit" runat="server" Text="Submit" />
		</div>
		<div>
		    First Name: <input type="text" id="firstName" maxlength="32" style="width:120px" />
		    Last Name: <input type="text" id="lastName" maxlength="32" style="width:120px" />
		    Age: <input type="text" id="age" maxlength="2" style="width:30px"/>
		    <input type="button" id="test" value="Set Data"/>
		</div>
		<div id="xml-t" class="clear">

		</div>
		<div>
			<textarea id="xml-d">

			</textarea>
		</div>
		<div class="clear">
		    <ul>
		        <asp:Repeater ID="_people" runat="server">
    		        <ItemTemplate>
    		            <li>
    		                <b>OrgPath: </b><%# Eval("OrgPath") %> 
    		                | <b>First Name: </b><%# Eval("FirstName") %> 
    		                | <b> Last Name: </b><%# Eval("LastName") %> 
    		                | <b> Age: </b><%# Eval("Age") %> 
    		            </li>    
		            </ItemTemplate>		        
		        </asp:Repeater>
		    </ul>
		</div>
		<asp:HiddenField ID="treeXml" runat="server" />
    </form>    
</body>
</html>
